Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp	(revision 138)
@@ -67,4 +67,15 @@
   }
 
+#undef  FUNCTION
+#define FUNCTION "Core::sort_and_unique"
+  //template <typename T>
+  std::vector<uint32_t> sort_and_unique (std::vector<uint32_t> v)
+  {
+    sort (v.begin(), v.end());
+    std::vector<uint32_t>::iterator it=std::unique(v.begin(), v.end());
+    v.erase(it,v.end());
+
+    return v;
+  }
 
 #undef  FUNCTION
@@ -112,4 +123,5 @@
   // Read bloc
   uint32_t                nb_read_bloc                                  ,//
+  uint32_t              * nb_inst_read                                  ,//[nb_read_bloc]
   uint32_t              * size_read_queue                               ,//[nb_read_bloc]
   uint32_t              * size_reservation_station                      ,//[nb_read_bloc]
@@ -118,4 +130,5 @@
   // Write bloc
   uint32_t                nb_write_bloc                                 ,//
+  uint32_t              * nb_inst_write                                 ,//[nb_write_bloc]
   uint32_t              * size_write_queue                              ,//[nb_write_bloc]
   uint32_t              * size_execute_queue                            ,//[nb_write_bloc]
@@ -128,7 +141,12 @@
   uint32_t              * size_load_queue                               ,//[nb_load_store_unit]
   uint32_t              * size_speculative_access_queue                 ,//[nb_load_store_unit]
+  uint32_t              * nb_store_queue_bank                           ,//[nb_load_store_unit]
+  uint32_t              * nb_load_queue_bank                            ,//[nb_load_store_unit]
   uint32_t              * nb_port_check                                 ,//[nb_load_store_unit]
   multi_execute_loop::execute_loop::Tspeculative_load_t  
                         * speculative_load                              ,//[nb_load_store_unit]
+  Tpredictor_t          * speculative_commit_predictor_scheme           ,//[nb_load_store_unit]
+  uint32_t             ** lsu_pht_size_counter                          ,//[nb_load_store_unit][1]
+  uint32_t             ** lsu_pht_nb_counter                            ,//[nb_load_store_unit][1]
   uint32_t              * nb_bypass_memory                              ,//[nb_load_store_unit]
   uint32_t              * nb_cache_port                                 ,//[nb_load_store_unit]
@@ -174,5 +192,5 @@
   uint32_t                nb_ooo_engine                                 ,
   uint32_t              * nb_rename_unit                                ,//[nb_ooo_engine]
-  uint32_t              * nb_inst_issue_slot                            ,//[nb_ooo_engine]
+//uint32_t              * nb_inst_issue_slot                            ,//[nb_ooo_engine]
   uint32_t              * nb_inst_reexecute                             ,//[nb_ooo_engine]
   uint32_t              * nb_inst_commit                                ,//[nb_ooo_engine]
@@ -182,4 +200,6 @@
   uint32_t              * size_re_order_buffer                          ,//[nb_ooo_engine]
   uint32_t              * nb_re_order_buffer_bank                       ,//[nb_ooo_engine]
+  multi_ooo_engine::ooo_engine::commit_unit::Tretire_ooo_scheme_t
+                        * retire_ooo_scheme                             ,//[nb_ooo_engine]
   Tpriority_t           * commit_priority                               ,//[nb_ooo_engine]
   Tload_balancing_t     * commit_load_balancing                         ,//[nb_ooo_engine]
@@ -191,6 +211,4 @@
   Tload_balancing_t     * issue_load_balancing                          ,//[nb_ooo_engine]
   uint32_t              * size_reexecute_queue                          ,//[nb_ooo_engine]
-  Tpriority_t           * reexecute_priority                            ,//[nb_ooo_engine]
-  Tload_balancing_t     * reexecute_load_balancing                      ,//[nb_ooo_engine]
 
   //Execute_loop
@@ -218,8 +236,8 @@
   uint32_t              * link_decod_bloc_with_thread                   ,//[nb_thread]
   uint32_t              * link_rename_bloc_with_front_end               ,//[nb_front_end]
-  bool                *** table_dispatch                                ,//[nb_ooo_engine][nb_inst_issue_slot][nb_read_bloc]
-  bool                 ** link_read_bloc_and_load_store_unit            ,//[nb_read_bloc][nb_load_store_unit]
+//bool                *** table_dispatch                                ,//[nb_ooo_engine][nb_inst_issue_slot][nb_read_bloc]
+  uint32_t              * link_read_bloc_with_load_store_unit           ,//[nb_load_store_unit]
   bool                 ** link_read_bloc_and_functionnal_unit           ,//[nb_read_bloc][nb_functionnal_unit]
-  bool                 ** link_write_bloc_and_load_store_unit           ,//[nb_write_bloc][nb_load_store_unit]
+  uint32_t              * link_write_bloc_with_load_store_unit          ,//[nb_load_store_unit]
   bool                 ** link_write_bloc_and_functionnal_unit          ,//[nb_write_bloc][nb_functionnal_unit]
   uint32_t              * link_load_store_unit_with_thread              ,//[nb_thread]
@@ -268,4 +286,5 @@
 
     _nb_read_bloc                            = nb_read_bloc                            ;
+    _nb_inst_read                            = nb_inst_read                            ;
     _size_read_queue                         = size_read_queue                         ;
     _size_reservation_station                = size_reservation_station                ;
@@ -273,4 +292,5 @@
 
     _nb_write_bloc                           = nb_write_bloc                           ;
+    _nb_inst_write                           = nb_inst_write                           ;
     _size_write_queue                        = size_write_queue                        ;
     _size_execute_queue                      = size_execute_queue                      ;
@@ -282,6 +302,11 @@
     _size_load_queue                         = size_load_queue                         ;
     _size_speculative_access_queue           = size_speculative_access_queue           ;
+    _nb_store_queue_bank                     = nb_store_queue_bank                     ;
+    _nb_load_queue_bank                      = nb_load_queue_bank                      ;
     _nb_port_check                           = nb_port_check                           ;
     _speculative_load                        = speculative_load                        ;
+    _speculative_commit_predictor_scheme     = speculative_commit_predictor_scheme     ;
+    _lsu_pht_size_counter                    = lsu_pht_size_counter                    ;
+    _lsu_pht_nb_counter                      = lsu_pht_nb_counter                      ;
     _nb_bypass_memory                        = nb_bypass_memory                        ;
     _nb_cache_port                           = nb_cache_port                           ;
@@ -321,5 +346,5 @@
     _nb_ooo_engine                           = nb_ooo_engine                           ;
     _nb_rename_unit                          = nb_rename_unit                          ;
-    _nb_inst_issue_slot                      = nb_inst_issue_slot                      ;
+//  _nb_inst_issue_slot                      = nb_inst_issue_slot                      ;
     _nb_inst_reexecute                       = nb_inst_reexecute                       ;
     _nb_inst_commit                          = nb_inst_commit                          ;
@@ -329,4 +354,5 @@
     _size_re_order_buffer                    = size_re_order_buffer                    ;
     _nb_re_order_buffer_bank                 = nb_re_order_buffer_bank                 ;
+    _retire_ooo_scheme                       = retire_ooo_scheme                       ;
     _commit_priority                         = commit_priority                         ;
     _commit_load_balancing                   = commit_load_balancing                   ;
@@ -337,6 +363,4 @@
     _issue_load_balancing                    = issue_load_balancing                    ;
     _size_reexecute_queue                    = size_reexecute_queue                    ;
-    _reexecute_priority                      = reexecute_priority                      ;
-    _reexecute_load_balancing                = reexecute_load_balancing                ;
 
     _nb_execute_loop                         = nb_execute_loop                         ;
@@ -362,8 +386,8 @@
     _link_decod_bloc_with_thread             = link_decod_bloc_with_thread             ;
     _link_rename_bloc_with_front_end         = link_rename_bloc_with_front_end         ;
-    _table_dispatch                          = table_dispatch                          ;
-    _link_read_bloc_and_load_store_unit      = link_read_bloc_and_load_store_unit      ;
+//  _table_dispatch                          = table_dispatch                          ;
+    _link_read_bloc_with_load_store_unit     = link_read_bloc_with_load_store_unit     ;
     _link_read_bloc_and_functionnal_unit     = link_read_bloc_and_functionnal_unit     ;
-    _link_write_bloc_and_load_store_unit     = link_write_bloc_and_load_store_unit     ;
+    _link_write_bloc_with_load_store_unit    = link_write_bloc_with_load_store_unit    ;
     _link_write_bloc_and_functionnal_unit    = link_write_bloc_and_functionnal_unit    ;
     _link_load_store_unit_with_thread        = link_load_store_unit_with_thread        ;
@@ -885,35 +909,70 @@
 
     {
-      std::vector<uint32_t> list_execute_loop [_nb_ooo_engine];
-
       // initialization counter
       for (uint32_t i=0; i<_nb_ooo_engine; ++i)
         _ooo_engine_nb_execute_loop [i] = 0;
-
-      // scan the dispatch table
+            
+      std::vector<uint32_t> list_execute_loop [_nb_ooo_engine];
+
+      for (uint32_t i=0; i<_nb_thread; ++i)
+        {
+          uint32_t num_front_end    = _link_context_with_thread [i].first;
+          uint32_t num_rename_bloc  = _link_rename_bloc_with_front_end [num_front_end];
+          uint32_t num_ooo_engine   = _link_rename_unit_with_rename_bloc [num_rename_bloc].first;
+          uint32_t num_execute_loop = _link_execute_unit_with_load_store_unit [i].first;
+          list_execute_loop[num_ooo_engine].push_back(num_execute_loop);
+
+          // One execute per ooo_engine
+          // for (uint32_t j=0; j<_nb_functionnal_unit; ++j)
+          //   if (_link_thread_and_functionnal_unit [i][j])
+          //     {
+          //       uint32_t num_execute_loop = _link_execute_unit_with_functionnal_unit [i].first;
+          //       list_execute_loop[num_ooo_engine].push_back(num_execute_loop);
+          //     }
+        }
+
+      // Sort and erase duplicate value
       for (uint32_t i=0; i<_nb_ooo_engine; ++i)
         {
-          for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
-            for (uint32_t k=0; k<_nb_read_bloc; ++k)
-              {
-                // have route between this slot's ooo_engine and an read_bloc
-                if (_table_dispatch [i][j][k])
-                  {
-                    uint32_t num_execute_loop = _link_read_unit_with_read_bloc [k].first;
-                    
-                    list_execute_loop[i].push_back(num_execute_loop);
-                  }
-              }
-                
-          {
-            sort  (list_execute_loop[i].begin(),
-                   list_execute_loop[i].end());
-            std::vector<uint32_t>::iterator it=std::unique(list_execute_loop[i].begin(),
-                                                           list_execute_loop[i].end());
-            list_execute_loop[i].erase(it,list_execute_loop[i].end());
-          }
-
+          list_execute_loop[i] = sort_and_unique (list_execute_loop[i]);
+
+          // {
+          //   sort  (list_execute_loop[i].begin(),
+          //          list_execute_loop[i].end());
+          //   std::vector<uint32_t>::iterator it=std::unique(list_execute_loop[i].begin(),
+          //                                                  list_execute_loop[i].end());
+          //   list_execute_loop[i].erase(it,list_execute_loop[i].end());
+          // }
+          
           _ooo_engine_nb_execute_loop [i] = list_execute_loop[i].size();
         }
+
+#if 0
+      // // scan the dispatch table
+      // for (uint32_t i=0; i<_nb_ooo_engine; ++i)
+      //   {
+      //     for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
+      //       for (uint32_t k=0; k<_nb_read_bloc; ++k)
+      //         {
+      //           // have route between this slot's ooo_engine and an read_bloc
+      //           if (_table_dispatch [i][j][k])
+      //             {
+      //               uint32_t num_execute_loop = _link_read_unit_with_read_bloc [k].first;
+                    
+      //               list_execute_loop[i].push_back(num_execute_loop);
+      //             }
+      //         }
+                
+      //     {
+      //       sort  (list_execute_loop[i].begin(),
+      //              list_execute_loop[i].end());
+      //       std::vector<uint32_t>::iterator it=std::unique(list_execute_loop[i].begin(),
+      //                                                      list_execute_loop[i].end());
+      //       list_execute_loop[i].erase(it,list_execute_loop[i].end());
+      //     }
+
+      //     _ooo_engine_nb_execute_loop [i] = list_execute_loop[i].size();
+      //   }
+#endif
 
       log_printf(TRACE,Core,FUNCTION,_("  * translate_ooo_engine_num_execute_loop"));
@@ -1029,5 +1088,5 @@
       }
     
-    ALLOC4(_network_table_dispatch                        ,bool             ,_nb_ooo_engine,_nb_inst_issue_slot[it1],_nb_execute_loop,_nb_read_unit[it3]);
+//  ALLOC4(_network_table_dispatch                        ,bool             ,_nb_ooo_engine,_nb_inst_issue_slot[it1],_nb_execute_loop,_nb_read_unit[it3]);
 //  ALLOC3(_ooo_engine_table_routing                      ,bool             ,_nb_ooo_engine,_nb_rename_unit[it1],_nb_inst_issue_slot[it1]);
 //  ALLOC3(_ooo_engine_table_issue_type                   ,bool             ,_nb_ooo_engine,_nb_inst_issue_slot[it1],_nb_type);
@@ -1035,105 +1094,141 @@
     ALLOC2(_list_load_store_unit_with_rename_unit         ,std::vector<uint32_t>,_nb_ooo_engine,_nb_rename_unit[it1]);
 
+    for (uint32_t num_thread=0; num_thread<_nb_thread; ++num_thread)
+      {
+        uint32_t num_front_end    = _link_context_with_thread [num_thread].first;
+        uint32_t num_rename_bloc  = _link_rename_bloc_with_front_end [num_front_end];
+        uint32_t num_ooo_engine   = _link_rename_unit_with_rename_bloc [num_rename_bloc].first;
+        uint32_t num_rename_unit  = _link_rename_unit_with_rename_bloc [num_rename_bloc].second;
+        
+        {
+          uint32_t num_load_store_unit = _link_load_store_unit_with_thread [num_thread];
+          
+          log_printf(TRACE,Core,FUNCTION,_("  * list_load_store_unit_with_rename_unit [%d][%d] = %d"),
+                     num_ooo_engine,
+                     num_rename_unit,
+                     num_load_store_unit);
+          
+          _list_load_store_unit_with_rename_unit [num_ooo_engine][num_rename_unit].push_back(num_load_store_unit);
+        }
+        
+        for (uint32_t num_functionnal_unit=0;
+             num_functionnal_unit<_nb_functionnal_unit;
+             ++num_functionnal_unit)
+          if (_link_thread_and_functionnal_unit[num_thread][num_functionnal_unit])
+            {
+              log_printf(TRACE,Core,FUNCTION,_("  * list_functionnal_unit_with_rename_unit [%d][%d] = %d"),
+                         num_ooo_engine,
+                         num_rename_unit,
+                         num_functionnal_unit);
+              
+              _list_functionnal_unit_with_rename_unit [num_ooo_engine][num_rename_unit].push_back(num_functionnal_unit);
+            }
+      }
+
     for (uint32_t i=0; i<_nb_ooo_engine; ++i)
       {
-//         log_printf(TRACE,Core,FUNCTION,_("  * ooo_engine_table_issue_type [%d]"),i);
-
-        // Init
-        for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
-          {
-            for (uint32_t k=0; k<_nb_execute_loop; ++k)
-              for (uint32_t l=0; l<_nb_read_unit[k]; ++l)
-                _network_table_dispatch [i][j][k][l] = false;
-//             for (uint32_t k=0; k<_nb_rename_unit[i]; ++k)
-//               _ooo_engine_table_routing [i][k][j] = false;
-//             for (uint32_t k=0; k<_nb_type; ++k)
-//               _ooo_engine_table_issue_type [i][j][k] = false;
-          }
-
-        std::vector<uint32_t> list_thread_with_inst_issue [_nb_inst_issue_slot[i]];
+#if 0
+// //         log_printf(TRACE,Core,FUNCTION,_("  * ooo_engine_table_issue_type [%d]"),i);
+
+//         // Init
+//         for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
+//           {
+//             for (uint32_t k=0; k<_nb_execute_loop; ++k)
+//               for (uint32_t l=0; l<_nb_read_unit[k]; ++l)
+//                 _network_table_dispatch [i][j][k][l] = false;
+//             // for (uint32_t k=0; k<_nb_rename_unit[i]; ++k)
+//             //   _ooo_engine_table_routing [i][k][j] = false;
+//             // for (uint32_t k=0; k<_nb_type; ++k)
+//             //   _ooo_engine_table_issue_type [i][j][k] = false;
+//           }
+
+//         std::vector<uint32_t> list_thread_with_inst_issue [_nb_inst_issue_slot[i]];
         
-        for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
-          {
-            for (uint32_t k=0; k<_nb_read_bloc; ++k)
-              // Test if the issue slot is linked with the read_bloc
-              if (_table_dispatch[i][j][k])
-                {
-                  pair_dual x = _link_read_unit_with_read_bloc[k];
-                  _network_table_dispatch [i][j][x.first][x.second] = true;
-
-                  // Test functional unit connected with this read bloc
-                  for (uint32_t l=0; l<_nb_functionnal_unit; ++l)
-                    {
-                      // the issue slot [j] is connected with the read bloc [k] and it's connected with the functionnal_unit [l]
-                      if (_link_read_bloc_and_functionnal_unit [k][l])
-                        {
-                          // Scan timing table, test if have an instruction
-//                           for (uint32_t m=0; m<_nb_type; ++m)
-//                             for (uint32_t n=0; n<_nb_operation; ++n)
-//                               if (_timing[l][m][n]._latence > 0)
-//                                 {
-//                                   log_printf(TRACE,Core,FUNCTION,_("   [%d][%d] -> true"),j,m);
+//         for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
+//           {
+//             for (uint32_t k=0; k<_nb_read_bloc; ++k)
+//               // Test if the issue slot is linked with the read_bloc
+//               if (_table_dispatch[i][j][k])
+//                 {
+//                   pair_dual x = _link_read_unit_with_read_bloc[k];
+//                   _network_table_dispatch [i][j][x.first][x.second] = true;
+
+//                   // Test functional unit connected with this read bloc
+//                   for (uint32_t l=0; l<_nb_functionnal_unit; ++l)
+//                     {
+//                       // the issue slot [j] is connected with the read bloc [k] and it's connected with the functionnal_unit [l]
+//                       if (_link_read_bloc_and_functionnal_unit [k][l])
+//                         {
+//                           // Scan timing table, test if have an instruction
+// //                           for (uint32_t m=0; m<_nb_type; ++m)
+// //                             for (uint32_t n=0; n<_nb_operation; ++n)
+// //                               if (_timing[l][m][n]._latence > 0)
+// //                                 {
+// //                                   log_printf(TRACE,Core,FUNCTION,_("   [%d][%d] -> true"),j,m);
                                   
-//                                   _ooo_engine_table_issue_type [i][j][m] = true;
-//                                   break;
-//                                 }
+// //                                   _ooo_engine_table_issue_type [i][j][m] = true;
+// //                                   break;
+// //                                 }
                           
-                          for (uint32_t m=0; m<_nb_thread; ++m)
-                            {
-                              list_thread_with_inst_issue [j].push_back(m);
+//                           for (uint32_t m=0; m<_nb_thread; ++m)
+//                             {
+//                               list_thread_with_inst_issue [j].push_back(m);
                               
-                              uint32_t num_front_end   = _link_context_with_thread [m].first;
-                              uint32_t num_rename_bloc = _link_rename_bloc_with_front_end[num_front_end];
-                              uint32_t num_rename_unit = _link_rename_unit_with_rename_bloc [num_rename_bloc].second;
+//                               uint32_t num_front_end   = _link_context_with_thread [m].first;
+//                               uint32_t num_rename_bloc = _link_rename_bloc_with_front_end[num_front_end];
+//                               uint32_t num_rename_unit = _link_rename_unit_with_rename_bloc [num_rename_bloc].second;
                               
-                              _list_functionnal_unit_with_rename_unit [i][num_rename_unit].push_back(l);
-                            }
-                        }
-                    }
-
-                  // Test load store unit connected with this read bloc
-                  for (uint32_t l=0; l<_nb_load_store_unit; ++l)
-                    {
-                      // Test load store unit connected with this read bloc
-                      if (_link_read_bloc_and_load_store_unit [k][l])
-                       {
-//                        _ooo_engine_table_issue_type [i][j][TYPE_MEMORY] = true;
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LBS)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LBS)._type][instruction_information(INSTRUCTION_L_LBS)._operation]._latence > 0);
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LBZ)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LBZ)._type][instruction_information(INSTRUCTION_L_LBZ)._operation]._latence > 0);
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LD )._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LD )._type][instruction_information(INSTRUCTION_L_LD )._operation]._latence > 0);
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LHS)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LHS)._type][instruction_information(INSTRUCTION_L_LHS)._operation]._latence > 0);
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LHZ)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LHZ)._type][instruction_information(INSTRUCTION_L_LHZ)._operation]._latence > 0);
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LWS)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LWS)._type][instruction_information(INSTRUCTION_L_LWS)._operation]._latence > 0);
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LWZ)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LWZ)._type][instruction_information(INSTRUCTION_L_LWZ)._operation]._latence > 0);
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_SB )._type] |= (_timing[l][instruction_information(INSTRUCTION_L_SB )._type][instruction_information(INSTRUCTION_L_SB )._operation]._latence > 0);
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_SD )._type] |= (_timing[l][instruction_information(INSTRUCTION_L_SD )._type][instruction_information(INSTRUCTION_L_SD )._operation]._latence > 0);
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_SH )._type] |= (_timing[l][instruction_information(INSTRUCTION_L_SH )._type][instruction_information(INSTRUCTION_L_SH )._operation]._latence > 0);
-//                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_SW )._type] |= (_timing[l][instruction_information(INSTRUCTION_L_SW )._type][instruction_information(INSTRUCTION_L_SW )._operation]._latence > 0);
-
-                          // the issue slot [j] is connected with the read bloc [k] and it's connected with the load_store_unit [l]
-                          for (uint32_t m=0; m<_nb_thread; ++m)
-                            {
-                              list_thread_with_inst_issue [j].push_back(m);
+//                               _list_functionnal_unit_with_rename_unit [i][num_rename_unit].push_back(l);
+//                             }
+//                         }
+//                     }
+
+//                   // Test load store unit connected with this read bloc
+//                   for (uint32_t l=0; l<_nb_load_store_unit; ++l)
+//                     {
+//                       // Test load store unit connected with this read bloc
+//                       if (_link_read_bloc_and_load_store_unit [k][l])
+//                        {
+// //                        _ooo_engine_table_issue_type [i][j][TYPE_MEMORY] = true;
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LBS)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LBS)._type][instruction_information(INSTRUCTION_L_LBS)._operation]._latence > 0);
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LBZ)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LBZ)._type][instruction_information(INSTRUCTION_L_LBZ)._operation]._latence > 0);
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LD )._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LD )._type][instruction_information(INSTRUCTION_L_LD )._operation]._latence > 0);
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LHS)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LHS)._type][instruction_information(INSTRUCTION_L_LHS)._operation]._latence > 0);
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LHZ)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LHZ)._type][instruction_information(INSTRUCTION_L_LHZ)._operation]._latence > 0);
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LWS)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LWS)._type][instruction_information(INSTRUCTION_L_LWS)._operation]._latence > 0);
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_LWZ)._type] |= (_timing[l][instruction_information(INSTRUCTION_L_LWZ)._type][instruction_information(INSTRUCTION_L_LWZ)._operation]._latence > 0);
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_SB )._type] |= (_timing[l][instruction_information(INSTRUCTION_L_SB )._type][instruction_information(INSTRUCTION_L_SB )._operation]._latence > 0);
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_SD )._type] |= (_timing[l][instruction_information(INSTRUCTION_L_SD )._type][instruction_information(INSTRUCTION_L_SD )._operation]._latence > 0);
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_SH )._type] |= (_timing[l][instruction_information(INSTRUCTION_L_SH )._type][instruction_information(INSTRUCTION_L_SH )._operation]._latence > 0);
+// //                        _ooo_engine_table_issue_type [i][j][instruction_information(INSTRUCTION_L_SW )._type] |= (_timing[l][instruction_information(INSTRUCTION_L_SW )._type][instruction_information(INSTRUCTION_L_SW )._operation]._latence > 0);
+
+//                           // the issue slot [j] is connected with the read bloc [k] and it's connected with the load_store_unit [l]
+//                           for (uint32_t m=0; m<_nb_thread; ++m)
+//                             {
+//                               list_thread_with_inst_issue [j].push_back(m);
                               
-                              uint32_t num_front_end   = _link_context_with_thread [m].first;
-                              uint32_t num_rename_bloc = _link_rename_bloc_with_front_end[num_front_end];
-                              uint32_t num_rename_unit = _link_rename_unit_with_rename_bloc [num_rename_bloc].second;
+//                               uint32_t num_front_end   = _link_context_with_thread [m].first;
+//                               uint32_t num_rename_bloc = _link_rename_bloc_with_front_end[num_front_end];
+//                               uint32_t num_rename_unit = _link_rename_unit_with_rename_bloc [num_rename_bloc].second;
                               
-                              log_printf(TRACE,Core,FUNCTION,_("  * list_load_store_unit_with_rename_unit [%d][%d][%d] = %d"),i,num_rename_unit,_list_load_store_unit_with_rename_unit [i][num_rename_unit].size(),l);
-
-                              _list_load_store_unit_with_rename_unit [i][num_rename_unit].push_back(l);
-                            }
-                        }
-                    }
-                }
-            // sort and erase duplicate value
-            {
-              sort  (list_thread_with_inst_issue [j].begin(),
-                     list_thread_with_inst_issue [j].end());
-              std::vector<uint32_t>::iterator it=unique(list_thread_with_inst_issue [j].begin(),
-                                                        list_thread_with_inst_issue [j].end());
-              list_thread_with_inst_issue [j].erase(it,list_thread_with_inst_issue [j].end());
-            }
-          }
+//                               log_printf(TRACE,Core,FUNCTION,_("  * list_load_store_unit_with_rename_unit [%d][%d][%d] = %d"),i,num_rename_unit,_list_load_store_unit_with_rename_unit [i][num_rename_unit].size(),l);
+
+//                               _list_load_store_unit_with_rename_unit [i][num_rename_unit].push_back(l);
+//                             }
+//                         }
+//                     }
+//                 }
+//             // sort and erase duplicate value
+//             list_thread_with_inst_issue [j] = sort_and_unique (list_thread_with_inst_issue [j]);
+
+//             // {
+//             //   sort  (list_thread_with_inst_issue [j].begin(),
+//             //          list_thread_with_inst_issue [j].end());
+//             //   std::vector<uint32_t>::iterator it=unique(list_thread_with_inst_issue [j].begin(),
+//             //                                             list_thread_with_inst_issue [j].end());
+//             //   list_thread_with_inst_issue [j].erase(it,list_thread_with_inst_issue [j].end());
+//             // }
+//           }
+#endif
 
         log_printf(TRACE,Core,FUNCTION,_("  * ooo_engine_table_routing [%d]"),i);
